mtype = { C, P };
mtype turn = P;
int last = -1;

active [2] proctype producer () {
	do
		:: (turn == P) ->
			printf("Produced %d\n", _pid);
			assert(last != _pid);
			last = _pid;
			turn = C;
	od
}

active [2] proctype consumer () {
	do
		:: (turn == C) ->
			printf("Consumer %d\n", _pid);
			assert(last != _pid);
			last = _pid;
			turn = P;
	od
}

/**
 * Explanation:
 * - both producers get past (turn == P) first
 * - one of the producers releases the turn to consumers
 * - one of the consumers prints its own message, then is preeempted
 * - the other producer prints its message, executes the remaining
 *   code releasing the turn to the Consumers and stops at (turn == P)
 * - the consumer overwrites turn with P
 * - the same process enters the loop and prints Produced again
 */
